Index: palm/trunk/SOURCE/biometeorology_mod.f90
===================================================================
--- palm/trunk/SOURCE/biometeorology_mod.f90	(revision 3525)
+++ palm/trunk/SOURCE/biometeorology_mod.f90	(revision 3569)
@@ -21,5 +21,5 @@
 !
 ! Current revisions:
-! -----------------
+! ------------------
 ! 
 ! 
@@ -27,4 +27,13 @@
 ! -----------------
 ! $Id$
+! Consistently use bio_fill_value everywhere,
+! move allocation and initialization of output variables to bio_check_data_output
+! and bio_3d_data_averaging,
+! dom_dwd_user, Schrempf:
+! - integration of UVEM module part from r3474 (edited)
+! - split UTCI regression into 6 parts
+! - all data_output_3d is now explicity casted to sp
+!
+! 3525 2018-11-14 16:06:14Z kanani
 ! Clean up, renaming from "biom" to "bio", summary of thermal index calculation
 ! into one module (dom_dwd_user)
@@ -49,17 +58,21 @@
 ! Authors:
 ! --------
-! @author Dominik Froehlich <dominik.froehlich@dwd.de>
-! @author Jaroslav Resler <resler@cs.cas.cz>
+! @author Dominik Froehlich <dominik.froehlich@dwd.de>, thermal indices
+! @author Jaroslav Resler <resler@cs.cas.cz>, mean radiant temperature
+! @author Michael Schrempf <schrempf@muk.uni-hannover.de>, uv exposure
 !
 !
 ! Description:
 ! ------------
-!> Human thermal comfort module calculating thermal perception of a sample
+!> Biometeorology module consisting of two parts:
+!> 1.: Human thermal comfort module calculating thermal perception of a sample
 !> human being under the current meteorological conditions.
+!> 2.: Calculation of vitamin-D weighted UV exposure
 !>
 !> @todo Alphabetical sorting of "USE ..." lists, "ONLY" list, variable declarations
 !>       (per subroutine: first all CHARACTERs, then INTEGERs, LOGICALs, REALs, )
 !> @todo Comments start with capital letter --> "!-- Include..." 
-!> @todo Variable and routine names strictly in lowercase letters and in English
+!> @todo uv_vitd3dose-->new output type necessary (cumulative)
+!> @todo consider upwelling radiation in UV
 !>
 !> @note nothing now
@@ -76,5 +89,5 @@
 
     USE basic_constants_and_equations_mod,                                     &
-       ONLY:  c_p, degc_to_k, l_v, magnus, sigma_sb
+       ONLY:  c_p, degc_to_k, l_v, magnus, sigma_sb, pi
 
     USE control_parameters,                                                    &
@@ -83,4 +96,7 @@
               simulated_time, surface_pressure
 
+    USE date_and_time_mod,                                                                                                        &
+        ONLY:  calc_date_and_time, day_of_year, time_utc
+
     USE grid_variables,                                                        &
        ONLY:  ddx, dx, ddy, dy
@@ -92,4 +108,8 @@
     USE kinds  !< Set precision of INTEGER and REAL arrays according to PALM
 
+    USE netcdf_data_input_mod,                                                                                                    &
+        ONLY:  netcdf_data_input_uvem, uvem_projarea_f, uvem_radiance_f,                                                          &
+               uvem_irradiance_f, uvem_integration_f, building_obstruction_f
+!
 !-- Import radiation model to obtain input for mean radiant temperature
     USE radiation_model_mod,                                                   &
@@ -106,14 +126,16 @@
     PRIVATE
 
+!
 !-- Declare all global variables within the module (alphabetical order)
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  tmrt_grid  !< tmrt results (Â°C)
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  perct      !< PT results   (Â°C)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  utci_grid  !< UTCI results (Â°C)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  pet_grid   !< PET results  (Â°C)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  utci       !< UTCI results (Â°C)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  pet        !< PET results  (Â°C)
+!
 !-- Grids for averaged thermal indices
     REAL(wp), DIMENSION(:), ALLOCATABLE   ::  mrt_av_grid   !< time average mean
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  perct_av      !< PT results (aver. input)   (Â°C)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  utci_av_grid  !< UTCI results (aver. input) (Â°C)
-    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  pet_av_grid   !< PET results (aver. input)  (Â°C)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  utci_av       !< UTCI results (aver. input) (Â°C)
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  pet_av        !< PET results (aver. input)  (Â°C)
 
 
@@ -123,6 +145,7 @@
     REAL ( wp ), PARAMETER ::  human_absorb = 0.7_wp  !< SW absorbtivity of a human body (Fanger 1972)
     REAL ( wp ), PARAMETER ::  human_emiss = 0.97_wp  !< LW emissivity of a human body after (Fanger 1972)
+    REAL ( wp ), PARAMETER ::  bio_fill_value = -9999._wp  !< set module fill value, replace by global fill value as soon as available
+!
 !--
-
     LOGICAL ::  aver_perct = .FALSE.  !< switch: do perct averaging in this module? (if .FALSE. this is done globally)
     LOGICAL ::  aver_q     = .FALSE.  !< switch: do e  averaging in this module?
@@ -135,4 +158,5 @@
     LOGICAL ::  average_trigger_pet   = .FALSE.  !< update averaged input on call to bio_pet?
 
+    LOGICAL ::  thermal_comfort = .TRUE.  !< Turn all thermal indices on or off
     LOGICAL ::  bio_perct     = .TRUE.   !< Turn index PT (instant. input) on or off
     LOGICAL ::  bio_perct_av  = .TRUE.   !< Turn index PT (averaged input) on or off
@@ -142,4 +166,52 @@
     LOGICAL ::  bio_utci_av   = .TRUE.   !< Turn index UTCI (averaged input) on or off
 
+!
+!-- UVEM parameters from here
+!
+!-- Declare all global variables within the module (alphabetical order)
+    INTEGER(iwp) ::  ai                      = 0  !< loop index in azimuth direction
+    INTEGER(iwp) ::  bi                      = 0  !< loop index of bit location within an 8bit-integer (one Byte)
+    INTEGER(iwp) ::  clothing                = 1  !< clothing (0=unclothed, 1=Arms,Hands,Face free, 3=Hand,Face free)
+    INTEGER(iwp) ::  iq                      = 0  !< loop index of irradiance quantity
+    INTEGER(iwp) ::  pobi                    = 0  !< loop index of the position of corresponding byte within ibset byte vektor
+    INTEGER(iwp) ::  obstruction_direct_beam = 0  !< Obstruction information for direct beam    
+    INTEGER(iwp) ::  zi                      = 0  !< loop index in zenith direction
+
+    INTEGER(KIND=1), DIMENSION(0:44)  ::  obstruction_temp1 = 0  !< temporary obstruction information stored with ibset 
+    INTEGER(iwp),    DIMENSION(0:359) ::  obstruction_temp2 = 0  !< restored temporary obstruction information from ibset file
+
+    INTEGER(iwp), DIMENSION(0:35,0:9) ::  obstruction       = 1  !< final 2D obstruction information array
+
+    LOGICAL ::  consider_obstructions = .TRUE.   !< namelist parameter (see documentation)
+    LOGICAL ::  sun_in_south          = .FALSE.  !< namelist parameter (see documentation)
+    LOGICAL ::  turn_to_sun           = .TRUE.   !< namelist parameter (see documentation)
+    LOGICAL ::  uv_exposure           = .FALSE.  !< namelist parameter (see documentation)
+
+    REAL(wp) ::  diffuse_exposure            =   0.0_wp  !< calculated exposure by diffuse radiation
+    REAL(wp) ::  direct_exposure             =   0.0_wp  !< calculated exposure by direct solar beam   
+    REAL(wp) ::  orientation_angle           =   0.0_wp  !< orientation of front/face of the human model    
+    REAL(wp) ::  projection_area_direct_beam =   0.0_wp  !< projection area for direct solar beam
+    REAL(wp) ::  saa                         = 180.0_wp  !< solar azimuth angle
+    REAL(wp) ::  startpos_human              =   0.0_wp  !< start value for azimuth interpolation of human geometry array
+    REAL(wp) ::  startpos_saa_float          =   0.0_wp  !< start value for azimuth interpolation of radiance array
+    REAL(wp) ::  sza                         =  20.0_wp  !< solar zenith angle
+    REAL(wp) ::  xfactor                     =   0.0_wp  !< relative x-position used for interpolation
+    REAL(wp) ::  yfactor                     =   0.0_wp  !< relative y-position used for interpolation
+
+    REAL(wp), DIMENSION(0:2)  ::  irradiance =   0.0_wp  !< iradiance values extracted from irradiance lookup table  
+
+    REAL(wp), DIMENSION(0:2,0:90) ::  irradiance_lookup_table      = 0.0_wp  !< irradiance lookup table
+    REAL(wp), DIMENSION(0:35,0:9) ::  integration_array            = 0.0_wp  !< solid angle factors for hemispherical integration
+    REAL(wp), DIMENSION(0:35,0:9) ::  projection_area              = 0.0_wp  !< projection areas of a human (all directions)
+    REAL(wp), DIMENSION(0:35,0:9) ::  projection_area_lookup_table = 0.0_wp  !< human geometry lookup table (projection areas)
+    REAL(wp), DIMENSION(0:71,0:9) ::  projection_area_direct_temp  = 0.0_wp  !< temporary projection area for direct solar beam
+    REAL(wp), DIMENSION(0:71,0:9) ::  projection_area_temp         = 0.0_wp  !< temporary projection area for all directions
+    REAL(wp), DIMENSION(0:35,0:9) ::  radiance_array               = 0.0_wp  !< radiance extracted from radiance_lookup_table  
+    REAL(wp), DIMENSION(0:71,0:9) ::  radiance_array_temp          = 0.0_wp  !< temporary radiance data
+
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  vitd3_exposure     !< result variable for instantaneous vitamin-D weighted exposures
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  vitd3_exposure_av  !< result variable for summation of vitamin-D weighted exposures
+
+    REAL(wp), DIMENSION(0:35,0:9,0:90) ::  radiance_lookup_table   = 0.0_wp  !< radiance lookup table
 
 !
@@ -150,6 +222,9 @@
     bio_check_parameters, bio_data_output_3d, bio_data_output_2d,              &
     bio_define_netcdf_grid, bio_get_thermal_index_input_ij, bio_header,        &
-    bio_init, bio_init_arrays, bio_parin, bio_perct, bio_perct_av, bio_pet,    &
-    bio_pet_av, bio_utci, bio_utci_av, time_bio_results
+    bio_init, bio_parin, bio_perct, bio_perct_av, bio_pet,                     &
+    bio_pet_av, bio_utci, bio_utci_av, thermal_comfort, time_bio_results,      &
+!
+!-- UVEM PUBLIC variables and methods
+    uvem_calc_exposure, uv_exposure
 
 !
@@ -160,65 +235,60 @@
        MODULE PROCEDURE bio_3d_data_averaging
     END INTERFACE bio_3d_data_averaging
-
+!
 !-- Calculate mtr from rtm fluxes and assign into 2D grid
     INTERFACE bio_calculate_mrt_grid
        MODULE PROCEDURE bio_calculate_mrt_grid
     END INTERFACE bio_calculate_mrt_grid
-
+!
 !-- Calculate static thermal indices PT, UTCI and/or PET
     INTERFACE bio_calculate_thermal_index_maps
        MODULE PROCEDURE bio_calculate_thermal_index_maps
     END INTERFACE bio_calculate_thermal_index_maps
-
+!
 !-- Calculate the dynamic index iPT (to be caled by the agent model)
     INTERFACE bio_calc_ipt
        MODULE PROCEDURE bio_calc_ipt
     END INTERFACE bio_calc_ipt
-
+!
 !-- Data output checks for 2D/3D data to be done in check_parameters
-     INTERFACE bio_check_data_output
-        MODULE PROCEDURE bio_check_data_output
-     END INTERFACE bio_check_data_output
-
+    INTERFACE bio_check_data_output
+       MODULE PROCEDURE bio_check_data_output
+    END INTERFACE bio_check_data_output
+!
 !-- Input parameter checks to be done in check_parameters
     INTERFACE bio_check_parameters
        MODULE PROCEDURE bio_check_parameters
     END INTERFACE bio_check_parameters
-
+!
 !-- Data output of 2D quantities
     INTERFACE bio_data_output_2d
        MODULE PROCEDURE bio_data_output_2d
     END INTERFACE bio_data_output_2d
-
+!
 !-- no 3D data, thus, no averaging of 3D data, removed
     INTERFACE bio_data_output_3d
        MODULE PROCEDURE bio_data_output_3d
     END INTERFACE bio_data_output_3d
-
+!
 !-- Definition of data output quantities
     INTERFACE bio_define_netcdf_grid
        MODULE PROCEDURE bio_define_netcdf_grid
     END INTERFACE bio_define_netcdf_grid
-
+!
 !-- Obtains all relevant input values to estimate local thermal comfort/stress
     INTERFACE bio_get_thermal_index_input_ij
        MODULE PROCEDURE bio_get_thermal_index_input_ij
     END INTERFACE bio_get_thermal_index_input_ij
-
+!
 !-- Output of information to the header file
     INTERFACE bio_header
        MODULE PROCEDURE bio_header
     END INTERFACE bio_header
-
+!
 !-- Initialization actions 
     INTERFACE bio_init
        MODULE PROCEDURE bio_init
     END INTERFACE bio_init
-
-!-- Initialization of arrays
-    INTERFACE bio_init_arrays
-       MODULE PROCEDURE bio_init_arrays
-    END INTERFACE bio_init_arrays
-
+!
 !-- Reading of NAMELIST parameters
     INTERFACE bio_parin
@@ -226,4 +296,9 @@
     END INTERFACE bio_parin
 
+!
+!-- Calculate UV exposure grid
+    INTERFACE uvem_calc_exposure
+       MODULE PROCEDURE uvem_calc_exposure
+    END INTERFACE uvem_calc_exposure
 
  CONTAINS
@@ -235,4 +310,8 @@
 !> Sum up and time-average biom input quantities as well as allocate
 !> the array necessary for storing the average.
+!> There is a considerable difference to the 3d_data_averaging subroutines
+!> used by other modules:
+!> For the thermal indices, the module needs to average the input conditions
+!> not the result!
 !------------------------------------------------------------------------------!
  SUBROUTINE bio_3d_data_averaging( mode, variable )
@@ -260,8 +339,36 @@
           CASE ( 'bio_perct*', 'bio_utci*', 'bio_pet*' )
 
-!--          Indices in unknown order as depending on input file, determine 
-!            first index to average und update only once
-             IF ( .NOT. average_trigger_perct .AND. .NOT. average_trigger_utci &
-                .AND. .NOT. average_trigger_pet ) THEN
+!
+!--          Averaging, as well as the allocation of the required grids must be
+!            done only once, independent from for how many thermal indices 
+!            averaged output is desired.
+!            Therefore wee need to memorize which index is the one that controls
+!            the averaging (what must be the first thermal index called).
+!            Indices are in unknown order as depending on the input file, 
+!            determine first index to average und update only once
+
+!--          Only proceed here if this was not done for any index before. This
+!            is done only once during the whole model run.
+             IF ( .NOT. average_trigger_perct .AND.                            &
+                  .NOT. average_trigger_utci  .AND.                            &
+                  .NOT. average_trigger_pet ) THEN
+!
+!--             Allocate the required grids
+                IF ( .NOT. ALLOCATED( perct_av ) ) THEN
+                   ALLOCATE( perct_av (nys:nyn,nxl:nxr) )
+                ENDIF
+                perct_av = REAL( bio_fill_value, KIND = wp )
+
+                IF ( .NOT. ALLOCATED( utci_av ) ) THEN
+                   ALLOCATE( utci_av (nys:nyn,nxl:nxr) )
+                ENDIF
+                utci_av = REAL( bio_fill_value, KIND = wp )
+
+                IF ( .NOT. ALLOCATED( pet_av ) ) THEN
+                   ALLOCATE( pet_av (nys:nyn,nxl:nxr) )
+                ENDIF
+                pet_av = REAL( bio_fill_value, KIND = wp )
+!
+!--             Memorize the first index called to control averaging
                 IF ( TRIM( variable ) == 'bio_perct*' ) THEN
                     average_trigger_perct = .TRUE.
@@ -274,40 +381,48 @@
                 ENDIF
              ENDIF
-
-!--          Only continue if updateindex
+!
+!--          Only continue if var is the index, that controls averaging.
+!            Break immediatelly (doing nothing) for the other indices.
              IF ( average_trigger_perct .AND. TRIM( variable ) /= 'bio_perct*') RETURN
              IF ( average_trigger_utci .AND. TRIM( variable ) /= 'bio_utci*')   RETURN
              IF ( average_trigger_pet  .AND. TRIM( variable ) /= 'bio_pet*')    RETURN
-
-!--          Set averaging switch to .TRUE. if not done by other module before!
+!
+!--          Now memorize which of the input grids are not averaged by other 
+!            modules. Set averaging switch to .TRUE. in that case.
              IF ( .NOT. ALLOCATED( pt_av ) )  THEN
                 ALLOCATE( pt_av(nzb:nzt+1,nys:nyn,nxl:nxr) )
                 aver_perct = .TRUE.
+                pt_av = 0.0_wp
              ENDIF
-             pt_av = 0.0_wp
 
              IF ( .NOT. ALLOCATED( q_av ) )  THEN
                 ALLOCATE( q_av(nzb:nzt+1,nys:nyn,nxl:nxr) )
                 aver_q = .TRUE.
+                q_av = 0.0_wp
              ENDIF
-             q_av = 0.0_wp
 
              IF ( .NOT. ALLOCATED( u_av ) )  THEN
                 ALLOCATE( u_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
                 aver_u = .TRUE.
+                u_av = 0.0_wp
              ENDIF
-             u_av = 0.0_wp
 
              IF ( .NOT. ALLOCATED( v_av ) )  THEN
                 ALLOCATE( v_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
                 aver_v = .TRUE.
+                v_av = 0.0_wp
              ENDIF
-             v_av = 0.0_wp
 
              IF ( .NOT. ALLOCATED( w_av ) )  THEN
                 ALLOCATE( w_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
                 aver_w = .TRUE.
+                w_av = 0.0_wp
              ENDIF
-             w_av = 0.0_wp
+
+          CASE ( 'uvem_vitd3dose*' )
+             IF ( .NOT. ALLOCATED( vitd3_exposure_av ) )  THEN
+                ALLOCATE( vitd3_exposure_av(nysg:nyng,nxlg:nxrg) )
+             ENDIF
+             vitd3_exposure_av = 0.0_wp
 
           CASE DEFAULT
@@ -335,6 +450,6 @@
 
           CASE ( 'bio_perct*', 'bio_utci*', 'bio_pet*' )
-
-!--          Only continue if updateindex
+!
+!--          Only continue if updateindex, see above
              IF ( average_trigger_perct .AND. TRIM( variable ) /= 'bio_perct*') &
                 RETURN
@@ -393,6 +508,16 @@
                 ENDDO
              ENDIF
-
-           CASE DEFAULT
+!
+!--       This is a cumulated dose. No mode == 'average' for this quantity.
+          CASE ( 'uvem_vitd3dose*' )
+             IF ( ALLOCATED( vitd3_exposure_av ) ) THEN
+                DO  i = nxlg, nxrg
+                   DO  j = nysg, nyng
+                      vitd3_exposure_av(j,i) = vitd3_exposure_av(j,i) + vitd3_exposure(j,i)
+                   ENDDO
+                ENDDO
+             ENDIF
+
+          CASE DEFAULT
              CONTINUE
 
@@ -409,12 +534,12 @@
 
           CASE ( 'bio_perct*', 'bio_utci*', 'bio_pet*' )
-
-!--          Only continue if update index
-             IF ( average_trigger_perct .AND. TRIM( variable ) /= 'bio_perct*') &
-                RETURN
-             IF ( average_trigger_utci .AND. TRIM( variable ) /= 'bio_utci*')  &
-                RETURN
-             IF ( average_trigger_pet  .AND. TRIM( variable ) /= 'bio_pet*')   &
-                RETURN
+!
+!--          Only continue if update index, see above
+             IF ( average_trigger_perct .AND.                                  &
+                TRIM( variable ) /= 'bio_perct*' ) RETURN
+             IF ( average_trigger_utci .AND.                                   &
+                TRIM( variable ) /= 'bio_utci*' ) RETURN
+             IF ( average_trigger_pet  .AND.                                   &
+                TRIM( variable ) /= 'bio_pet*' ) RETURN
 
              IF ( ALLOCATED( pt_av ) .AND. aver_perct ) THEN
@@ -422,5 +547,6 @@
                    DO  j = nys, nyn
                       DO  k = nzb, nzt+1
-                         pt_av(k,j,i) = pt_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                         pt_av(k,j,i) = pt_av(k,j,i) /                         &
+                            REAL( average_count_3d, KIND=wp )
                       ENDDO
                    ENDDO
@@ -432,5 +558,6 @@
                    DO  j = nys, nyn
                       DO  k = nzb, nzt+1
-                         q_av(k,j,i) = q_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                         q_av(k,j,i) = q_av(k,j,i) /                           &
+                            REAL( average_count_3d, KIND=wp )
                       ENDDO
                    ENDDO
@@ -442,5 +569,6 @@
                    DO  j = nysg, nyng
                       DO  k = nzb, nzt+1
-                         u_av(k,j,i) = u_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                         u_av(k,j,i) = u_av(k,j,i) /                           &
+                            REAL( average_count_3d, KIND=wp )
                       ENDDO
                    ENDDO
@@ -452,5 +580,6 @@
                    DO  j = nysg, nyng
                       DO  k = nzb, nzt+1
-                         v_av(k,j,i) = v_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                         v_av(k,j,i) = v_av(k,j,i) /                           &
+                            REAL( average_count_3d, KIND=wp )
                       ENDDO
                    ENDDO
@@ -462,12 +591,17 @@
                    DO  j = nysg, nyng
                       DO  k = nzb, nzt+1
-                         w_av(k,j,i) = w_av(k,j,i) / REAL( average_count_3d, KIND=wp )
+                         w_av(k,j,i) = w_av(k,j,i) /                           &
+                            REAL( average_count_3d, KIND=wp )
                       ENDDO
                    ENDDO
                 ENDDO
              ENDIF
-
-!--          Udate thermal indices with derived averages
+!
+!--          Udate all thermal index grids with updated averaged input
              CALL bio_calculate_thermal_index_maps ( .TRUE. )
+
+!
+!--     No averaging for UVEM since we are calculating a dose (only sum is
+!--     calculated and saved to av.nc file)
 
         END SELECT
@@ -485,5 +619,5 @@
 !> Check data output for biometeorology model
 !------------------------------------------------------------------------------!
- SUBROUTINE bio_check_data_output( var, unit )
+ SUBROUTINE bio_check_data_output( var, unit, i, ilen, k )
 
     USE control_parameters,                                                    &
@@ -495,9 +629,74 @@
     CHARACTER (LEN=*) ::  var      !< The variable in question
 
+    INTEGER(iwp) ::  i      !<
+    INTEGER(iwp) ::  ilen   !<   
+    INTEGER(iwp) ::  k      !<
 
     SELECT CASE ( TRIM( var ) )
-     
-       CASE( 'bio_mrt', 'bio_pet*', 'bio_perct*', 'bio_utci*' )
+!
+!-- Allocate a temporary array with the desired output dimensions.
+       CASE ( 'bio_mrt')
           unit = 'degree_C'
+          IF ( .NOT. ALLOCATED( tmrt_grid ) )  THEN
+             ALLOCATE( tmrt_grid (nys:nyn,nxl:nxr) )
+          ENDIF
+          tmrt_grid = REAL( bio_fill_value, KIND = wp )
+
+       CASE ( 'bio_perct*' )
+          unit = 'degree_C'
+          IF ( .NOT. ALLOCATED( perct ) )  THEN
+             ALLOCATE( perct (nys:nyn,nxl:nxr) )
+          ENDIF
+          perct = REAL( bio_fill_value, KIND = wp )
+
+       CASE ( 'bio_utci*' )
+          unit = 'degree_C'
+          IF ( .NOT. ALLOCATED( utci ) )  THEN
+             ALLOCATE( utci (nys:nyn,nxl:nxr) )
+          ENDIF
+          utci = REAL( bio_fill_value, KIND = wp )
+
+       CASE ( 'bio_pet*' )
+          unit = 'degree_C'
+          IF ( .NOT. ALLOCATED( pet ) )  THEN
+             ALLOCATE( pet (nys:nyn,nxl:nxr) )
+          ENDIF
+          pet = REAL( bio_fill_value, KIND = wp )
+
+       CASE ( 'uvem_vitd3*' )
+          IF (  .NOT.  uv_exposure )  THEN
+             message_string = 'output of "' // TRIM( var ) // '" requi' //     &
+                      'res a namelist &uvexposure_par'
+             CALL message( 'uvem_check_data_output', 'UV0001', 1, 2, 0, 6, 0 )
+          ENDIF
+          IF ( k == 0  .OR.  data_output(i)(ilen-2:ilen) /= '_xy' )  THEN
+             message_string = 'illegal value for data_output: "' //            &
+                              TRIM( var ) // '" & only 2d-horizontal ' //      &
+                              'cross sections are allowed for this value'
+             CALL message( 'check_parameters', 'PA0111', 1, 2, 0, 6, 0 )
+          ENDIF
+          unit = 'IU/s'
+          IF ( .NOT. ALLOCATED( vitd3_exposure ) )  THEN
+             ALLOCATE( vitd3_exposure(nysg:nyng,nxlg:nxrg) )
+          ENDIF
+          vitd3_exposure = 0.0_wp
+
+       CASE ( 'uvem_vitd3dose*' )
+          IF (  .NOT.  uv_exposure )  THEN
+             message_string = 'output of "' // TRIM( var ) // '" requi' //     &
+                      'res  a namelist &uvexposure_par'
+             CALL message( 'uvem_check_data_output', 'UV0001', 1, 2, 0, 6, 0 )
+          ENDIF
+          IF ( k == 0  .OR.  data_output(i)(ilen-2:ilen) /= '_xy' )  THEN
+             message_string = 'illegal value for data_output: "' //            &
+                              TRIM( var ) // '" & only 2d-horizontal ' //      &
+                              'cross sections are allowed for this value'
+             CALL message( 'check_parameters', 'PA0111', 1, 2, 0, 6, 0 )
+          ENDIF
+          unit = 'IU/av-h'
+          IF ( .NOT. ALLOCATED( vitd3_exposure_av ) )  THEN
+             ALLOCATE( vitd3_exposure_av(nysg:nyng,nxlg:nxrg) )
+          ENDIF
+          vitd3_exposure_av = 0.0_wp
 
        CASE DEFAULT
@@ -506,7 +705,8 @@
     END SELECT
 
-    IF ( unit /= 'illegal' )  THEN
+    IF ( thermal_comfort .AND. unit == 'degree_C' )  THEN
 !
 !--    Futher checks if output belongs to biometeorology
+!      Break if required modules "radiation" and "humidity" are not running.
        IF ( .NOT.  radiation ) THEN
           message_string = 'output of "' // TRIM( var ) // '" require'         &
@@ -541,8 +741,8 @@
     IMPLICIT NONE
 
-
+!
 !--    Disabled as long as radiation model not available
 
-       IF ( .NOT. humidity )  THEN
+       IF ( thermal_comfort  .AND.  .NOT.  humidity )  THEN
           message_string = 'The estimation of thermal comfort requires '    // &
                            'air humidity information, but humidity module ' // &
@@ -562,8 +762,6 @@
 !------------------------------------------------------------------------------!
  SUBROUTINE bio_data_output_2d( av, variable, found, grid, local_pf,           &
-                                      two_d, nzb_do, nzt_do, fill_value )
-
-    USE indices,                                                               &
-       ONLY: nxl, nxl, nxr, nxr, nyn, nyn, nys, nys, nzb, nzt
+                                two_d, nzb_do, nzt_do )
+
 
     USE kinds
@@ -571,5 +769,5 @@
 
     IMPLICIT NONE
-
+!
 !-- Input variables
     CHARACTER (LEN=*), INTENT(IN) ::  variable    !< Char identifier to select var for output
@@ -577,6 +775,5 @@
     INTEGER(iwp), INTENT(IN)      ::  nzb_do      !< Unused. 2D. nz bottom to nz top
     INTEGER(iwp), INTENT(IN)      ::  nzt_do      !< Unused.
-    REAL(wp), INTENT(in)          ::  fill_value  !< Fill value for unassigned locations
-
+!
 !-- Output variables
     CHARACTER (LEN=*), INTENT(OUT) ::  grid   !< Grid type (always "zu1" for biom)
@@ -584,7 +781,6 @@
     LOGICAL, INTENT(OUT)           ::  two_d  !< Flag parameter that indicates 2D variables, horizontal cross sections, must be .TRUE.
     REAL(wp), DIMENSION(nxl:nxr,nys:nyn,nzb_do:nzt_do) ::  local_pf  !< Temp. result grid to return
-
+!
 !-- Internal variables
-    CHARACTER (LEN=:), allocatable ::  variable_short  !< Trimmed version of char variable
     INTEGER(iwp) ::  i        !< Running index, x-dir
     INTEGER(iwp) ::  j        !< Running index, y-dir
